
package ca.canadapost.cpcdp.ncshipping.generated.ncshipment;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.NormalizedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * <p>Java class for DeliverySpecType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="DeliverySpecType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;all>
 *         &lt;element name="service-code" type="{http://www.canadapost.ca/ws/ncshipment-v4}ServiceCodeType"/>
 *         &lt;element name="sender" type="{http://www.canadapost.ca/ws/ncshipment-v4}SenderType"/>
 *         &lt;element name="destination" type="{http://www.canadapost.ca/ws/ncshipment-v4}DestinationType"/>
 *         &lt;element name="options" minOccurs="0">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;sequence>
 *                   &lt;element name="option" type="{http://www.canadapost.ca/ws/ncshipment-v4}OptionType" maxOccurs="20"/>
 *                 &lt;/sequence>
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *         &lt;element name="parcel-characteristics" type="{http://www.canadapost.ca/ws/ncshipment-v4}ParcelCharacteristicsType"/>
 *         &lt;element name="notification" type="{http://www.canadapost.ca/ws/ncshipment-v4}NotificationType" minOccurs="0"/>
 *         &lt;element name="preferences" type="{http://www.canadapost.ca/ws/ncshipment-v4}PreferencesType"/>
 *         &lt;element name="references" type="{http://www.canadapost.ca/ws/ncshipment-v4}ReferencesType" minOccurs="0"/>
 *         &lt;element name="customs" type="{http://www.canadapost.ca/ws/ncshipment-v4}CustomsType" minOccurs="0"/>
 *         &lt;element name="settlement-info" type="{http://www.canadapost.ca/ws/ncshipment-v4}SettlementInfoType" minOccurs="0"/>
 *       &lt;/all>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DeliverySpecType", propOrder = {

})
public class DeliverySpecType {

    @XmlElement(name = "service-code", required = true)
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    protected String serviceCode;
    @XmlElement(required = true)
    protected SenderType sender;
    @XmlElement(required = true)
    protected DestinationType destination;
    protected DeliverySpecType.Options options;
    @XmlElement(name = "parcel-characteristics", required = true)
    protected ParcelCharacteristicsType parcelCharacteristics;
    protected NotificationType notification;
    @XmlElement(required = true)
    protected PreferencesType preferences;
    protected ReferencesType references;
    protected CustomsType customs;
    @XmlElement(name = "settlement-info")
    protected SettlementInfoType settlementInfo;

    /**
     * Gets the value of the serviceCode property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getServiceCode() {
        return serviceCode;
    }

    /**
     * Sets the value of the serviceCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setServiceCode(String value) {
        this.serviceCode = value;
    }

    /**
     * Gets the value of the sender property.
     * 
     * @return
     *     possible object is
     *     {@link SenderType }
     *     
     */
    public SenderType getSender() {
        return sender;
    }

    /**
     * Sets the value of the sender property.
     * 
     * @param value
     *     allowed object is
     *     {@link SenderType }
     *     
     */
    public void setSender(SenderType value) {
        this.sender = value;
    }

    /**
     * Gets the value of the destination property.
     * 
     * @return
     *     possible object is
     *     {@link DestinationType }
     *     
     */
    public DestinationType getDestination() {
        return destination;
    }

    /**
     * Sets the value of the destination property.
     * 
     * @param value
     *     allowed object is
     *     {@link DestinationType }
     *     
     */
    public void setDestination(DestinationType value) {
        this.destination = value;
    }

    /**
     * Gets the value of the options property.
     * 
     * @return
     *     possible object is
     *     {@link DeliverySpecType.Options }
     *     
     */
    public DeliverySpecType.Options getOptions() {
        return options;
    }

    /**
     * Sets the value of the options property.
     * 
     * @param value
     *     allowed object is
     *     {@link DeliverySpecType.Options }
     *     
     */
    public void setOptions(DeliverySpecType.Options value) {
        this.options = value;
    }

    /**
     * Gets the value of the parcelCharacteristics property.
     * 
     * @return
     *     possible object is
     *     {@link ParcelCharacteristicsType }
     *     
     */
    public ParcelCharacteristicsType getParcelCharacteristics() {
        return parcelCharacteristics;
    }

    /**
     * Sets the value of the parcelCharacteristics property.
     * 
     * @param value
     *     allowed object is
     *     {@link ParcelCharacteristicsType }
     *     
     */
    public void setParcelCharacteristics(ParcelCharacteristicsType value) {
        this.parcelCharacteristics = value;
    }

    /**
     * Gets the value of the notification property.
     * 
     * @return
     *     possible object is
     *     {@link NotificationType }
     *     
     */
    public NotificationType getNotification() {
        return notification;
    }

    /**
     * Sets the value of the notification property.
     * 
     * @param value
     *     allowed object is
     *     {@link NotificationType }
     *     
     */
    public void setNotification(NotificationType value) {
        this.notification = value;
    }

    /**
     * Gets the value of the preferences property.
     * 
     * @return
     *     possible object is
     *     {@link PreferencesType }
     *     
     */
    public PreferencesType getPreferences() {
        return preferences;
    }

    /**
     * Sets the value of the preferences property.
     * 
     * @param value
     *     allowed object is
     *     {@link PreferencesType }
     *     
     */
    public void setPreferences(PreferencesType value) {
        this.preferences = value;
    }

    /**
     * Gets the value of the references property.
     * 
     * @return
     *     possible object is
     *     {@link ReferencesType }
     *     
     */
    public ReferencesType getReferences() {
        return references;
    }

    /**
     * Sets the value of the references property.
     * 
     * @param value
     *     allowed object is
     *     {@link ReferencesType }
     *     
     */
    public void setReferences(ReferencesType value) {
        this.references = value;
    }

    /**
     * Gets the value of the customs property.
     * 
     * @return
     *     possible object is
     *     {@link CustomsType }
     *     
     */
    public CustomsType getCustoms() {
        return customs;
    }

    /**
     * Sets the value of the customs property.
     * 
     * @param value
     *     allowed object is
     *     {@link CustomsType }
     *     
     */
    public void setCustoms(CustomsType value) {
        this.customs = value;
    }

    /**
     * Gets the value of the settlementInfo property.
     * 
     * @return
     *     possible object is
     *     {@link SettlementInfoType }
     *     
     */
    public SettlementInfoType getSettlementInfo() {
        return settlementInfo;
    }

    /**
     * Sets the value of the settlementInfo property.
     * 
     * @param value
     *     allowed object is
     *     {@link SettlementInfoType }
     *     
     */
    public void setSettlementInfo(SettlementInfoType value) {
        this.settlementInfo = value;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *       &lt;sequence>
     *         &lt;element name="option" type="{http://www.canadapost.ca/ws/ncshipment-v4}OptionType" maxOccurs="20"/>
     *       &lt;/sequence>
     *     &lt;/restriction>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "options"
    })
    public static class Options {

        @XmlElement(name = "option", required = true)
        protected List<OptionType> options;

        /**
         * Gets the value of the options property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the options property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getOptions().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link OptionType }
         * 
         * 
         */
        public List<OptionType> getOptions() {
            if (options == null) {
                options = new ArrayList<OptionType>();
            }
            return this.options;
        }

    }

}
