
package ca.canadapost.cpcdp.ncshipping.generated.ncshipment;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for NonContractShipmentType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="NonContractShipmentType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;all>
 *         &lt;element name="requested-shipping-point" type="{http://www.canadapost.ca/ws/ncshipment-v4}PostalCodeType" minOccurs="0"/>
 *         &lt;element name="delivery-spec" type="{http://www.canadapost.ca/ws/ncshipment-v4}DeliverySpecType"/>
 *         &lt;element name="create-public-key" minOccurs="0">
 *           &lt;simpleType>
 *             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}boolean">
 *               &lt;pattern value="true"/>
 *               &lt;pattern value="false"/>
 *             &lt;/restriction>
 *           &lt;/simpleType>
 *         &lt;/element>
 *         &lt;element name="create-qr-code" minOccurs="0">
 *           &lt;simpleType>
 *             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}boolean">
 *               &lt;pattern value="true"/>
 *               &lt;pattern value="false"/>
 *             &lt;/restriction>
 *           &lt;/simpleType>
 *         &lt;/element>
 *       &lt;/all>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "NonContractShipmentType", propOrder = {

})
@XmlRootElement(name = "non-contract-shipment")
public class NonContractShipment {

    @XmlElement(name = "requested-shipping-point")
    protected String requestedShippingPoint;
    @XmlElement(name = "delivery-spec", required = true)
    protected DeliverySpecType deliverySpec;
    @XmlElement(name = "create-public-key")
    protected Boolean createPublicKey;
    @XmlElement(name = "create-qr-code", defaultValue = "false")
    protected Boolean createQrCode;

    /**
     * Gets the value of the requestedShippingPoint property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getRequestedShippingPoint() {
        return requestedShippingPoint;
    }

    /**
     * Sets the value of the requestedShippingPoint property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setRequestedShippingPoint(String value) {
        this.requestedShippingPoint = value;
    }

    /**
     * Gets the value of the deliverySpec property.
     * 
     * @return
     *     possible object is
     *     {@link DeliverySpecType }
     *     
     */
    public DeliverySpecType getDeliverySpec() {
        return deliverySpec;
    }

    /**
     * Sets the value of the deliverySpec property.
     * 
     * @param value
     *     allowed object is
     *     {@link DeliverySpecType }
     *     
     */
    public void setDeliverySpec(DeliverySpecType value) {
        this.deliverySpec = value;
    }

    /**
     * Gets the value of the createPublicKey property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public Boolean isCreatePublicKey() {
        return createPublicKey;
    }

    /**
     * Sets the value of the createPublicKey property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setCreatePublicKey(Boolean value) {
        this.createPublicKey = value;
    }

    /**
     * Gets the value of the createQrCode property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public Boolean isCreateQrCode() {
        return createQrCode;
    }

    /**
     * Sets the value of the createQrCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setCreateQrCode(Boolean value) {
        this.createQrCode = value;
    }

}
